/* This is a test plug-in.
 * It mainly contains stubs
 * for the functions the plug-ins
 * look for
 */

package anecho.JamochaMUD.plugins;

import anecho.JamochaMUD.JMConfig;
import anecho.JamochaMUD.MuSocket;

import java.util.*;

/* We have to import EnumPlugIns if we want to interact
 * with the MU* itself, as EnumPlugIns contains the
 * API to do so.  It is possible for you to interact
 * with EnumPlugIns directly, but hopefully by using
 * the Loader object, all plugins would not need to be
 * substantially rewritten incase this changes in the future */

public class TestPlugIn implements PlugInterface {

    JMConfig settings;

    public void setSettings(JMConfig mainSettings) {
        this.settings = mainSettings;
    }

    /** This method returns the name of the plug-in */
    public String PlugInName() {
        // Nothin'
        return "Test Plug-in";
    }

    /** A basic description of the plug-in that is shown in
     * the JamochaMUD &quot;Manage Plugins" dialogue box
     */
    public String PlugInDescription() {
        return "TestPlugIn is a sample plug-in used to show developers how to create their own plug-ins.";
    }

    /** This indicates what type of plugin this is, ie: input or output.
     * This setting will affect what information JamochaMUD tries to
     * process with this plug-in.
     * If the plug-in is set to a setting that JamochaMUD does not
     * understand than the plugin will be ignored.
     */
    public String PlugInType() {
        return "TestPlugIn -> PlugInType";
    }

    /** This is the main method of the plug-in.  It is passed both
     * a string for processing as well as and associated MU* that
     * the message is coming from/going to.
     */
    public String PlugMain(String jamochaString, MuSocket mu) {
        System.out.println("TestPlugIn received: " + jamochaString);
        return jamochaString;
    }

    /** This method is called by the &quot;Properties" option in
     * the JamochaMUD &quot;Manage plugins" dialogue box.
     * Any settings that you wish the user to have access to
     * can be configured through this method
     */
    public void PlugInProperties() {
    }

    /** This method is called as soon as the plugin is first loaded.
     * It is useful for loading or configuring anything needed by
     * the plug-in at start-up (such as loading settings).
     */
    public void InitialiseAtLoad(){
    }

    public void SetAtHalt(){
    }

    /** This method tells JamochaMUD whether this plugin should have
     * its own person configuration directory where it can keep its
     * settings.
     * A return of false means that the plugin has no settings that
     * need to be saved to disk.
     * A return of true tells JamochaMUD to create a settings directory
     * for this plugin (if one does not already exist).
     */
    public boolean haveConfig() {
        return false;
    }

    public boolean HasProperties() {
        return false;
    }

}
